/* ---------------------------------------------------------- */
/*  kv_game.c                                                 */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
@brief		KomeVader gamemain
@author		rerofumi
@since		Aug.04.2007
*/
/*-----------------------------------------------------
Copyright (C) 2007 rerofumi <rero2@yuumu.org>
-  Kome wo kame.
------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "kome_display_drv.h"
#include "kv_game.h"
#include "kv_sound.h"
#include "kv_display.h"
#include "kv_myship.h"
#include "kv_shot.h"
#include "kv_enemy.h"
#include "kv_mystery.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

/* --- Q[O[o^C} */
int  m_game_timer;

/* --- Q[XRA */
int  m_game_score;

/* --- nCXRA */
int  m_game_hiscore;

/* --- @c */
int  m_game_rest;

/* --- Xe[W */
int  m_game_stage;

/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

/*-------------------------------*/
/* interrupt vector              */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* interface                                            */
/*------------------------------------------------------*/

/* --- kvGameInitialize() */
/**
* Q[
* 
*/
void kvGameInitialize(void)
{
	/* --- ϐ */
	m_game_score = 0;
	m_game_rest = 2;
	m_game_stage = 0;

	/* --- ʏ */
	kvDisplayGameStart(m_game_hiscore, m_game_rest);

	/* --- IuWFNg */
	kvMyshipInitialize();
	kvMyshipShieldInitialize();
	kvShotInitialize();
	kvEnemyInitialize(m_game_stage);
	kvMysteryInitialize();

	/* --- X^[g~[WbN */
	kvSoundRequest(1, SE_START);
}


/* --- kvGameGetScore() */
/**
* Q[XRA擾
* 
* @return vC[̃Q[XRAlԂ
*/
int kvGameGetScore(void)
{
	return(m_game_score);
}


/* --- kvGameGetHiscore() */
/**
* nCXRA擾
* 
* @return ܂ł̃nCXRAlԂ
*/
int kvGameGetHiscore(void)
{
	return(m_game_hiscore);
}


/* --- kvGameSetHiscore() */
/**
* nCXRAݒ(Np)
* 
* @param hiscore [in] ݒ肷nCXRAl
*/
void kvGameSetHiscore(int hiscore)
{
	m_game_hiscore = hiscore;
}


/*------------------------------------------------------*/
/* game manage                                          */
/*------------------------------------------------------*/

/* --- kvGameTick() */
/**
* Q[is
* 
* @return sȂ GAME_EXECUTEAGAME_DONE ŏIAXe[g
*/
int kvGameTick(void)
{
	int  result;
	int  pts;
	int i;

	/* --- VSync wait ƕ\ */
	kvDisplayVSync();

	/* --- @̃Rg[ */
	result = kvMyshipTick();
	if (result == MYSHIP_HIT) {
		m_game_rest -= 1;
		if (m_game_rest >= 0) {
			kvDisplayMyshipRest(m_game_rest);
		}
	}

	/* --- Vbg̊Ǘ */
	pts = kvShotTick();
	if (pts > 0) {
		m_game_score += pts;
		kvDisplayScore(SCREEN_WIDTH-320+256, 40, m_game_score);
	}

	/* --- GړǗ */
	for(i=0; i<70; i++) {
		result = kvEnemyTick();
		if (result == ENEMY_INVADE) {
			if (m_game_hiscore < m_game_score) {
				m_game_hiscore = m_game_score;
			}
			/* NQ[I[o[ */
			return(GAME_DONE);
		}
	}
	/* - G̑SŊmF */
	if (kvEnemyGetNum() == 0) {
		/* ̃Xe[W */
		m_game_stage += 1;
		kvEnemyInitialize(m_game_stage);
		kvMyshipShieldInitialize();
	}

	/* --- ~Xe[ */
	kvMysteryTick();

	/* --- c@ԂQ[ł */
	if (m_game_rest < 0) {
		if (m_game_hiscore < m_game_score) {
			m_game_hiscore = m_game_score;
		}
		return(GAME_DONE);
	}
	return(GAME_EXECUTE);
}



/*------------------------------------------------------*/
/* local routine                                        */
/*------------------------------------------------------*/

