/* ---------------------------------------------------------- */
/*  kv_myship.c                                               */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief		KomeVader myship & shield manage
    @author		rerofumi
    @since		Aug.04.2007
*/
/*-----------------------------------------------------
 Copyright (C) 2007 rerofumi <rero2@yuumu.org>
 -  Kome wo kame.
 ------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "kome_display_drv.h"
#include "kome_input_drv.h"
#include "kv_sound.h"
#include "kv_display.h"
#include "kv_shot.h"
#include "kv_myship.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

#define SHIELD_SIZE_W  4
#define SHIELD_SIZE_H  8
#define SHIELD_Y  (SCREEN_HEIGHT-(240-184)-1)
#define SHIELD_NUM  48*10


#define MYSHIP_Y (SCREEN_HEIGHT-(240-216)-1)

/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

//! g[`JIuWFNg\
typedef struct {
  short  pos_x, pos_y;
  char   flag;
} KVShield, PKVShield;


/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

//! @̈ʒu
int  m_myship_x;

//! @AGԃ^C}[
int  m_myship_muteki;

//! @Aꎞ^C}[
int  m_myship_miss;

//! @Vbg̃gKo
int  m_myship_trigger;

//! g[`JIuWFNgǗ
KVShield m_shield[SHIELD_NUM];

/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

//! g[`J 
void crash_shield(int num);

/*-------------------------------*/
/* interrupt vector              */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* interface                                            */
/*------------------------------------------------------*/

/* --- kvMyshipInitialize() */
/**
 * @
 * 
 */
void kvMyshipInitialize(void)
{
  m_myship_x = 10;
  m_myship_muteki = 60;
  m_myship_miss = 0;
}


/* --- kvMyshipTick() */
/**
 * @ړ
 * 
 * @return ʏȂ MYSHIP_DONEAMYSHIP_HIT ň@
 *
 */
int kvMyshipTick(void)
{
  int  post_x;
  int  inkey;

  post_x = m_myship_x;

  /* --- ꎞAj[V */
  if (m_myship_miss > 0) {
    if (((m_myship_miss / 4) & 0x01) == 0) {
      kvDisplayMyship(m_myship_x, MYSHIP_Y, DISPLAY_MYSHIP_MISS_1);
    }
    else {
      kvDisplayMyship(m_myship_x, MYSHIP_Y, DISPLAY_MYSHIP_MISS_2);
    }
    /* ړŏI */
    m_myship_miss -= 1;
    if (m_myship_miss == 0) {
      kvDisplayMyship(m_myship_x, MYSHIP_Y, DISPLAY_MYSHIP_ERASE);
      m_myship_muteki = 60;
      return(MYSHIP_HIT);
    }
    return(MYSHIP_DONE);
  }

  /* --- ړǗ */
  komeInputRead(&inkey);
  if ((m_myship_x > 1) && ((inkey & KIN_Left) != 0)) {
    m_myship_x -= 1;
  }
  if ((m_myship_x < (SCREEN_WIDTH-(320-226))) && ((inkey & KIN_Right) != 0)) {
    m_myship_x += 1;
  }

  /* --- U */
  if ((inkey & KIN_Button1) != 0) {
    if (m_myship_trigger == 0) {
      kvShotMyshotRequest(m_myship_x+6, MYSHIP_Y-8);
    }
    m_myship_trigger = 1;
  }
  else {
    m_myship_trigger = 0;
  }

  /* --- \ */
  if ((post_x != m_myship_x) || (m_myship_muteki > 0)) {
    /* - G */
    if (m_myship_muteki > 0) {
      m_myship_muteki -= 1;
    }
    /* - Ot[ʒu */
    kvDisplayMyship(post_x, MYSHIP_Y, DISPLAY_MYSHIP_ERASE);
    /* - Vʒuŕ` */
    if ((m_myship_muteki % 2) == 0) {
      kvDisplayMyship(m_myship_x, MYSHIP_Y, DISPLAY_MYSHIP_NORMAL);
    }
  }

  return(MYSHIP_DONE);
}


/* --- kvMyshipCheckHit() */
/**
 * @ƒe̓蔻
 * 
 * @return ʏȂ MYSHIP_DONEAMYSHIP_HIT ł
 *
 */
int kvMyshipCheckHit(int x, int y)
{
  if ((m_myship_muteki > 0) || (m_myship_miss > 0)) {
    return(MYSHIP_DONE);
  }
  /*  */
  if (y >= MYSHIP_Y) {
    if (x > m_myship_x) {
      if (x < (m_myship_x + 13)) {
	kvSoundRequest(0, SE_MISS);
	m_myship_miss = 90;
	return(MYSHIP_HIT);
      }
    }
  }

  return(MYSHIP_DONE);
}


/* --- kvMyshipShieldIitialize() */
/**
 * g[`J
 * 
 */
void kvMyshipShieldInitialize(void)
{
  int  i;
  int  x, y;

  for(i=0; i<SHIELD_NUM; i++) {
    /* O񂩌 */
    y = SHIELD_Y + (8 * (i / (SHIELD_NUM / 2)));
    /* ʒu */
    x = (((i%(SHIELD_NUM/2)) / 6) * 56) + (((i%(SHIELD_NUM/2)) % 6) * 4) + 24;
    /* IuWFNg` */
    m_shield[i].pos_x = x;
    m_shield[i].pos_y = y;
    m_shield[i].flag = 1;
    /* LN^[\NGXg */
    kvDisplayShield(x, y, DISPLAY_SHIELD_NORMAL);
  }
}


/* --- kvMyshipShieldCheckHit() */
/**
 * g[`Jƒe̓蔻
 * 
 * @return ʏȂ MYSHIP_DONEAMYSHIP_HIT ł
 *
 */
int kvMyshipShieldCheckHit(int x, int y)
{
  int  i, hit;

  hit = 0;
  if ((SHIELD_Y < y) && ((SHIELD_Y+16) > y)) {
    if (SHIELD_Y+SHIELD_SIZE_H < y) {
      /* - ̗ */
      for(i=(SHIELD_NUM/2); i<SHIELD_NUM; i++) {
	if (m_shield[i].flag == 0) continue;
	if ((m_shield[i].pos_x <= x) &&
	    ((m_shield[i].pos_x+SHIELD_SIZE_W > x))) {
	  /* hit */
	  crash_shield(i);
	  hit = 1;
	}
      }
    }
    else {
      /* - ̗ */
      for(i=0; i<(SHIELD_NUM/2); i++) {
	if (m_shield[i].flag == 0) continue;
	if ((m_shield[i].pos_x <= x) &&
	    ((m_shield[i].pos_x+SHIELD_SIZE_W > x))) {
	  /* hit */
	  crash_shield(i);
	  hit = 1;
	}
      }
    }
  }

  if (hit != 0) {
    return(MYSHIP_HIT);
  }
  return(MYSHIP_DONE);
}


/*------------------------------------------------------*/
/* local routine                                        */
/*------------------------------------------------------*/

/* --- g[`J */
void crash_shield(int num)
{
  int  p;

  m_shield[num].flag = 0;
  kvDisplayShield(m_shield[num].pos_x,
		  m_shield[num].pos_y,
		  DISPLAY_SHIELD_ERASE);
  /* ---  */
  if (num >= (SHIELD_NUM/2)) {
    p = num - (SHIELD_NUM/2);
    if (m_shield[p].flag == 1) {
      kvDisplayShield(m_shield[p].pos_x,
		      m_shield[p].pos_y,
		      DISPLAY_SHIELD_UP);
    }
  }
  /* ---  */
  if (num < (SHIELD_NUM/2)) {
    p = num + (SHIELD_NUM/2);
    if (m_shield[p].flag == 1) {
      kvDisplayShield(m_shield[p].pos_x,
		      m_shield[p].pos_y,
		      DISPLAY_SHIELD_DOWN);
    }
  }
  /* ---  */
  if ((num % 6) != 0) {
    p = num - 1;
    if (m_shield[p].flag == 1) {
      kvDisplayShield(m_shield[p].pos_x,
		      m_shield[p].pos_y,
		      DISPLAY_SHIELD_LEFT);
    }
  }
  /* --- E */
  if ((num % 6) != 5) {
    p = num + 1;
    if (m_shield[p].flag == 1) {
      kvDisplayShield(m_shield[p].pos_x,
		      m_shield[p].pos_y,
		      DISPLAY_SHIELD_RIGHT);
    }
  }
}
