/* ---------------------------------------------------------- */
/*  kv_title.c                                                */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief		KomeVader title & gameover screen
    @author		rerofumi
    @since		Aug.04.2007
*/
/*-----------------------------------------------------
 Copyright (C) 2007 rerofumi <rero2@yuumu.org>
 -  Kome wo kame.
 ------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "kome_display_drv.h"
#include "kome_input_drv.h"
#include "kv_title.h"
#include "kv_sound.h"
#include "kv_display.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

/* --- T[NS */
#include "graphic/splash.h"

/* --- ^Cg */
#include "graphic/title.h"


/* --- XvbV\^C} */
int  m_title_timer;

/* --- X^[g_Ń^C} */
int  m_title_start_wait;


/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

/*-------------------------------*/
/* interrupt vector              */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* interface                                            */
/*------------------------------------------------------*/

/* --- kvTitleSplashInitialize() */
/**
 * T[NXvbVʏ
 * 
 * @return Ȃ TITLE_DONEAȊOŎs
 *
 */
int kvTitleSplashInitialize(void)
{
  komeDisplaySwCrtc(0);
  komeDisplayClearPacket();
  komeDisplayClearScreen();
  komeDisplayPattern((SCREEN_WIDTH-320)/2+80, (SCREEN_HEIGHT-240)/2+92,
		     PATTERN_SPLASH_W, PATTERN_SPLASH_H,
		     pattern_splash);
  komeDisplayASync();
  komeDisplaySwCrtc(1);

  /* --- XvbV\^C}[ */
  m_title_timer = 180;

  return(TITLE_DONE);
}


/* --- kvTitleSplash() */
/**
 * T[NXvbVʕ\is
 * 
 * @return \Ȃ TITLE_EXECUTEATITLE_DONE ŎXe[g
 *
 */
int kvTitleSplash(void)
{
  int  inkey;

  /* --- VSync */
  komeDisplayVSync();

  /* --- {^Ŕ΂ */
  if (m_title_timer < 120) {
    komeInputRead(&inkey);
    if ((inkey & KIN_Button1) != 0) {
      m_title_timer = 1;
    }
  }
  /* --- \^C} */
  m_title_timer -= 1;
  if (m_title_timer <= 0) {
    return(TITLE_DONE);
  }
  return(TITLE_EXECUTE);
}


/* --- kvTitleInitialize() */
/**
 * ^Cgʏ
 * 
 * @return Ȃ TITLE_DONEAȊOŎs
 *
 */
int kvTitleInitialize(void)
{
   komeDisplaySwCrtc(0);
  komeDisplayClearPacket();
  komeDisplayClearScreen();
  komeDisplayPattern((SCREEN_WIDTH-320)/2, (SCREEN_HEIGHT-320)/2,
		     PATTERN_TITLE_W, PATTERN_TITLE_H,
		     pattern_title);
  komeDisplayASync();
  komeDisplaySwCrtc(1);

  /* --- _Ń^C}[ */
  m_title_timer = 0;
  m_title_start_wait = 0;

  return(TITLE_DONE);
}


/* --- kvTitle() */
/**
 * ^Cgʕ\is
 * 
 * @return \Ȃ TITLE_EXECUTEATITLE_DONE ŎXe[g
 *
 */
int kvTitle(void)
{
  int  inkey;

  /* --- VSync */
  komeDisplayVSync();

  /* --- X^[g̓_ */
  m_title_timer += 1;
  if ((m_title_timer % 30) == 0) {
    if ((m_title_timer % 60) < 30) {
      komeDisplayString((SCREEN_WIDTH-320)/2+116, (SCREEN_HEIGHT-240)/2+180, "PUSH BUTTON");
    }
    else {
      komeDisplayString((SCREEN_WIDTH-320)/2+116, (SCREEN_HEIGHT-240)/2+180, "           ");
    }
  }

  /* --- {^ŃX^[g */
  if ((m_title_timer > 30) && (m_title_start_wait == 0)) {
    komeInputRead(&inkey);
    if ((inkey & KIN_Button1) != 0) {
      m_title_start_wait = 90;
      kvSoundRequest(2, SE_PUSH_START);
    }
  }
  /* --- \^C} */
  if (m_title_start_wait > 0) {
    m_title_start_wait -= 1;
    m_title_timer -= (m_title_timer % 15);
    m_title_timer += 14;
    if (m_title_start_wait <= 0) {
      return(TITLE_DONE);
    }
  }
  return(TITLE_EXECUTE);
}


/* --- kvTitleGameoverInitialize() */
/**
 * Q[I[o[ʏ
 * 
 * @param score [in] ̃vC[XRA
 * @param hiscore [int] nCXRA\p
 * @return Ȃ TITLE_DONEAȊOŎs
 *
 */
int kvTitleGameoverInitialize(int score, int hiscore)
{
  /* ===  */
  komeDisplaySwCrtc(0);
  komeDisplayClearPacket();
  komeDisplayClearScreen();
  komeDisplayString(SCREEN_WIDTH-320+124, 116, "GAME OVER");
  komeDisplayASync();
  komeDisplayString(SCREEN_WIDTH-320+248,  32, "SCORE");
  komeDisplayString(SCREEN_WIDTH-320+248,  56, "HISCORE");
  kvDisplayScore(SCREEN_WIDTH-320+256, 40, score);
  kvDisplayHiscore(SCREEN_WIDTH-320+256, 64, hiscore);
  komeDisplayASync();
  komeDisplaySwCrtc(1);

  /* --- Q[I[o[\^C}[ */
  m_title_timer = 300;

  /* --- TEhNGXg */
  kvSoundRequest(2, SE_GAMEOVER);
  kvSoundRequest(0, SE_STOP);
  kvSoundRequest(1, SE_STOP);
  kvSoundRequest(3, SE_STOP);

  return(TITLE_DONE);
}


/* --- kvTitleGameover() */
/**
 * Q[I[o[ʕ\is
 * 
 * @return \Ȃ TITLE_EXECUTEATITLE_DONE ŎXe[g
 *
 */
int kvTitleGameover(void)
{
  int  inkey;

  /* --- VSync */
  komeDisplayVSync();

  /* --- {^Ŕ΂ */
  if (m_title_timer < 240) {
    komeInputRead(&inkey);
    if ((inkey & KIN_Button1) != 0) {
      m_title_timer = 1;
    }
  }
  /* --- \^C} */
  m_title_timer -= 1;
  if (m_title_timer <= 0) {
    return(TITLE_DONE);
  }
  return(TITLE_EXECUTE);
}

